#
# Skeleton PloneTestCase
#

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.CMFPlone.tests import PloneTestCase

import common
common.installProducts()


class TestSimpleVocabulary(PloneTestCase.PloneTestCase):

    def afterSetUp(self):
        common.installWithinPortal(self.portal)
        self.atvm = common.getATVM(self.portal)

    def setupSimpleVocabularyContainer(self):
        self.loginPortalOwner()
        self.atvm.invokeFactory('SimpleVocabulary','svtest')
        self.atvm.svtest.setTitle('Test Vocabulary')


    def setupSimpleVocabulary(self):
        self.setupSimpleVocabularyContainer()
        self.atvm.svtest.invokeFactory('SimpleVocabularyTerm', 'key1')
        self.atvm.svtest.key1.setTitle('Value 1')
        self.logout()

    def testSetupSimpleVocabulary(self):
        # Test setup
        self.setupSimpleVocabulary()

    def testGetVocabularyByName(self):
        # Test if vocab can be fetched
        self.setupSimpleVocabulary()
        vocab = self.atvm.getVocabularyByName('svtest')
        self.assertEqual(vocab.Title(), 'Test Vocabulary')

    def testAddTerm(self):
        self.setupSimpleVocabularyContainer()
        svtest = self.atvm.svtest
        svtest.addTerm('foo','bar')
        self.assertEqual(svtest.foo.getVocabularyValue(), 'bar')

    def testImportCSVwoTitlerow(self):
        self.setupSimpleVocabularyContainer()
        csvdata= """\
"key1","value1"
"key2","value2"
"","value3"
"""
        svtest = self.atvm.svtest
        svtest.importCSV(csvdata)
        vocab=svtest.getVocabularyDict()

        # first both lines used?
        self.assertEqual(vocab['key1'],'value1')
        self.assertEqual(vocab['key2'],'value2')

        # there must be an Value value3 with a uuid as key
        for key in vocab.keys():
            if vocab[key] == 'value3':
                self.failUnless(key!="")

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestSimpleVocabulary))
    return suite

if __name__ == '__main__':
    framework()
